/**
 *  main.h
 *	CS 6610 - Advanced Computer Graphics I
 *  Zach Gildersleeve
 *	Sept. 21, 2006
 *	
 *	Main header file, contains constants and function declarations.
 */

const GLint WINDOW_WIDTH	= 900;	// the window width
const GLint WINDOW_HEIGHT	= 600;	// the window height

const GLint CHECK_SIZE		= 5;	// the size of one square on the checkered floor
const GLint GROUND_SIZE		= 200;	// the overall dimensions of the ground plane
const GLfloat FLOOR_HEIGHT	= -3.2;	// the height of the ground plane

const GLint UPPER_LEFT_ARM	= 1;	// the respective name of each limb,
const GLint LOWER_LEFT_ARM	= 2;	// used for selection
const GLint UPPER_RIGHT_ARM	= 3;
const GLint LOWER_RIGHT_ARM	= 4;
const GLint UPPER_LEFT_LEG	= 5;
const GLint LOWER_LEFT_LEG	= 6;
const GLint UPPER_RIGHT_LEG	= 7;
const GLint LOWER_RIGHT_LEG	= 8;

const GLint BUFFER_SIZE		= 512;	// the selection buffer size

const GLint NUMBER_OF_JOINTS = 8;	// the number of joints
const GLint STARTING_ROTATION = 20;	// the standard starting rotation for each joint

const GLint CB_DEPTH_BUFFER = 0;	// call-back for the depth buffer toggle
const GLint CB_ACTION_BUTTON = 1;	// call-back for the start/stop button
const GLint CB_RESET = 2;			// call-back for the reset button

void TimerFunc(int value);
GLvoid Init(GLvoid);
void Reshape(int Width, int Height);
void glui_cb(int control);
GLvoid drawGround(GLvoid);
void selectObjects(int button, int state, int x, int y);
GLvoid processHits(GLint hits, GLuint buffer[]);
void motion(int x, int y);
void Display(void);
GLvoid drawRobot(GLenum mode);
GLvoid moveRobot(GLfloat speedScale);
int main(int argc, char** argv);