/*
 *  main.cpp
 *  6610project1
 *
 *  Created by Zach Gildersleeve on 9/16/06.
 *
 *	
 *
 *
 */

#include "main.h"

GLfloat armSwing = 20.0;
GLfloat lowerArmSwing = -20.0;
GLfloat armSpeed = 5.0;

GLfloat legSwing = 20.0;
GLfloat lowerLegSwingMax = 20.0;
GLfloat lowerLegSwing = 20.0;
GLfloat legSpeed = 5.0;

GLfloat forward = 0.0;

GLint degree[9] = {0};

GLint currentSelection = 0;

GLint animation = 1;

void TimerFunc(int value)
{
	glutPostRedisplay();
	glutTimerFunc(100, TimerFunc, 1);
}

GLvoid Init(GLvoid)
{
	GLfloat  ambientLight[] = { 0.2f, 0.2f, 0.2f, 1.0f };		// color of overall ambient light
	GLfloat  diffuseLight[] = { 0.5f, 0.5f, 0.5f, 1.0f };		// color of light
	GLfloat	 lightPos[] = { 25.0f, 25.0f, 25.0f, 0.0};			// position of light
	GLfloat  spotDir[] = {0.0, 0.0, 0.0, 0.0};					// direction of light

	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
		
	glEnable(GL_LIGHTING);
		glEnable(GL_LIGHT0);	
		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambientLight);
		glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuseLight);
		glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
		glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, spotDir);
		
	glEnable(GL_COLOR_MATERIAL);
	glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
	
	glClearColor(0.0, 0.0, 0.0, 0.0);
}

void Reshape(int Width, int Height)
{
    glViewport (0, 0, (GLsizei) Width, (GLsizei) Height);
	
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0, (GLfloat) Width / (GLfloat) Height, 1.0, 200.0);
	
    glMatrixMode(GL_MODELVIEW);	
    glLoadIdentity();
	gluLookAt(2.0, 2.0, 15.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
}

GLvoid drawGround(GLvoid)
{
	GLint x, z;
	GLint counter = 0;
	
	for (x = -GROUND_SIZE; x < GROUND_SIZE; x += CHECK_SIZE)
	{
		for (z = -GROUND_SIZE; z < GROUND_SIZE; z += CHECK_SIZE)
		{
			glColor3f(1.0, 1.0, 1.0);
			if (counter % 2 == 0)
			{
			glColor3f(0.2, 0.2, 1.0);
			}
				glBegin(GL_QUADS);
					glNormal3d(0, 1, 0);
					glVertex3f(x, FLOOR_HEIGHT, z);
					glVertex3f(x, FLOOR_HEIGHT, z + CHECK_SIZE);
					glVertex3f(x + CHECK_SIZE, FLOOR_HEIGHT, z + CHECK_SIZE);
					glVertex3f(x + CHECK_SIZE, FLOOR_HEIGHT, z);
				glEnd();			
		//	}
			counter++;
		}
		counter++;
	}
}

void selectObjects(int button, int state, int x, int y)
{
	GLuint selectBuf[BUFFER_SIZE];		// array of returned hit records
	GLint hits;							// number of hits returned
	GLint viewport[4];					// array to hold current viewport values
	
	if (button != GLUT_LEFT_BUTTON || state != GLUT_DOWN)
	{
		animation = 1;
		return;
	}

	glGetIntegerv(GL_VIEWPORT, viewport);

	glSelectBuffer(BUFFER_SIZE, selectBuf);
	(void) glRenderMode(GL_SELECT);
	glInitNames();
	glPushName(0);
	
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluPickMatrix((GLdouble) x, (GLdouble) (viewport[3] - y), 1.0, 1.0, viewport);
    gluPerspective(45.0, (GLfloat) (viewport[2] - viewport[0])/(GLfloat)(viewport[3] - viewport[1]), 0.1, 200.0);

	glMatrixMode(GL_MODELVIEW);
	drawRobot(GL_SELECT);
	
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	Reshape(viewport[2], viewport[3]);
	
	hits = glRenderMode(GL_RENDER);
	if (hits > 0)
	{
		processHits(hits, selectBuf, x, y);	
		animation = 0;	
	}

}

GLvoid processHits(GLint hits, GLuint buffer[], GLint x, GLint y)
{
	GLint i, j;
	GLuint names, *ptr;

	ptr = (GLuint *) buffer;
	for (i = 0; i < hits; i++)
	{
		names = *ptr;
		ptr++;		// skip over number of names on name stack
		ptr++;		// skip over min z-value
		ptr++;		// skip over max z-value
		
		for (j = 0; j < names; j++)		// returns top (depth-wise) name
		{
			currentSelection = *ptr;
			ptr++;
		}
	}
}

void motion(int x, int y)
{
	degree[currentSelection] = static_cast<GLint> (sqrt(x * x + y * y));
}

void Display(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glPushMatrix();
		drawGround();
	glPopMatrix();
	
	drawRobot(GL_RENDER);
}

GLvoid drawRobot(GLenum mode)
{    
	glPushMatrix();
	
	moveRobot(1.0);
	
		glPushMatrix();							// Body of Robot
			glColor3f(0.5, 0.9, 0.5);
			glScalef(.5, 1.0, .5);

			glBegin(GL_QUADS);			
				glNormal3d(0, 1, 0);			// Top
				glVertex3f( 1.0f, 1.0f,-1.0f);
				glVertex3f(-1.0f, 1.0f,-1.0f);
				glVertex3f(-1.0f, 1.0f, 1.0f);
				glVertex3f( 1.0f, 1.0f, 1.0f);

				glNormal3d(0, -1, 0);			// Bottom
				glVertex3f( 1.0f,-1.0f, 1.0f);
				glVertex3f(-1.0f,-1.0f, 1.0f);
				glVertex3f(-1.0f,-1.0f,-1.0f);
				glVertex3f( 1.0f,-1.0f,-1.0f);

				glNormal3d(0, 0, 1);			// Front
				glVertex3f( 1.0f, 1.0f, 1.0f);
				glVertex3f(-1.0f, 1.0f, 1.0f);
				glVertex3f(-1.0f,-1.0f, 1.0f);
				glVertex3f( 1.0f,-1.0f, 1.0f);

				glNormal3d(0, 0, -1);			// Back
				glVertex3f( 1.0f,-1.0f,-1.0f);
				glVertex3f(-1.0f,-1.0f,-1.0f);
				glVertex3f(-1.0f, 1.0f,-1.0f);
				glVertex3f( 1.0f, 1.0f,-1.0f);

				glNormal3d(-1, 0, 0);			// Left
				glVertex3f(-1.0f, 1.0f, 1.0f);
				glVertex3f(-1.0f, 1.0f,-1.0f);
				glVertex3f(-1.0f,-1.0f,-1.0f);
				glVertex3f(-1.0f,-1.0f, 1.0f);

				glNormal3d(1, 0, 0);			// Right
				glVertex3f( 1.0f, 1.0f,-1.0f);
				glVertex3f( 1.0f, 1.0f, 1.0f);
				glVertex3f( 1.0f,-1.0f, 1.0f);
				glVertex3f( 1.0f,-1.0f,-1.0f);
			glEnd();
		glPopMatrix();
		
		glPushMatrix();							// Tatoo
			glScalef(0.5, 0.5, 0.5);
			glTranslatef(-0.8, 0.4, 1.1);
			glLineWidth(3.0);
			glColor3f(1.0, 0.0, 0.0);
						
			glBegin(GL_LINE_STRIP);
				glVertex2f(0.0, 0.8);
				glVertex2d(0, 1);
				glVertex2d(1, 1);
				glVertex2d(0, 0);
				glVertex2d(1, 0);
				glVertex2f(1.0, 0.2);
			glEnd();
			
			glTranslatef(0.5, -0.7, 0.0);
			
			glBegin(GL_LINE_STRIP);
				glVertex2f(1.0, 0.8);
				glVertex2d(1, 1);
				glVertex2d(0, 1);
				glVertex2d(0, 0);
				glVertex2d(1, 0);
				glVertex2f(1.0, 0.5);
				glVertex2f(0.5, 0.5);
			glEnd();
		glPopMatrix();
		
		glColor3f(0.5, 0.9, 0.5);
		
		glPushMatrix();							// Head
			glTranslatef(0.0, 1.5, 0.0);
			glutSolidCube(0.65);
		glPopMatrix();
		
		glPushMatrix();							// Upper left arm
			if(mode == GL_SELECT)
				glLoadName(UPPER_LEFT_ARM);
				
			glTranslatef(0.0, 1.0, 0.0);
			glRotatef(-(armSwing) + degree[1], 1.0, 0.0, 0.0);
			
			glPushMatrix();
				glScalef(0.35, 1.0, 0.35);
				glTranslatef(2.25, -0.5, 0.0);
				glutSolidCube(1.0);
			glPopMatrix();
			
			if(mode == GL_SELECT)				// Lower left arm
				glLoadName(LOWER_LEFT_ARM);

			glTranslatef(0.0, -1.0, 0.0);
			glRotatef((armSwing < 5)?(lowerArmSwing / 2) + degree[2]:
					  (lowerArmSwing * (armSwing / 10)) + degree[2], 1.0, 0.0, 0.0);
			glScalef(0.35, 1.0, 0.35);
			glTranslatef(2.25, -0.55, 0.0);
			glutSolidCube(1.0);
		glPopMatrix();
		
		glPushMatrix();							// Upper right arm
			if(mode == GL_SELECT)
				glLoadName(UPPER_RIGHT_ARM);
				
			glTranslatef(0.0, 1.0, 0.0);
			glRotatef(armSwing + degree[3], 1.0, 0.0, 0.0);
			
			glPushMatrix();
				glScalef(0.35, 1.0, 0.35);
				glTranslatef(-2.25, -0.5, 0.0);
				glutSolidCube(1.0);
			glPopMatrix();
			
			if(mode == GL_SELECT)				// Lower right arm
				glLoadName(LOWER_RIGHT_ARM);
				
			glTranslatef(0.0, -1.0, 0.0);

			glRotatef((armSwing < -5)?(lowerArmSwing * (armSwing / -10)) + degree[4]:
					  (lowerArmSwing / 2) + degree[4], 1.0, 0.0, 0.0);
			glScalef(0.35, 1.0, 0.35);
			glTranslatef(-2.25, -0.55, 0.0);
			glutSolidCube(1.0);
		glPopMatrix();
		
		glPushMatrix();							// Upper left leg
			if(mode == GL_SELECT)
				glLoadName(UPPER_LEFT_LEG);
				
			glTranslatef(0.75, -1.0, 0.0);
			glRotatef(legSwing + degree[5], 1.0, 0.0, 0.0);
			
			glPushMatrix();
				glScalef(0.45, 1.0, 0.45);
				glTranslatef(0.0, -.65, 0.0);
				glutSolidCube(1.0);
			glPopMatrix();
			
			if(mode == GL_SELECT)				// Lower left leg
				glLoadName(LOWER_LEFT_LEG);
			glTranslatef(0.0, -1.0, 0.0);
			glRotatef((legSwing < 5.0)?(lowerLegSwing * (fabs(legSwing) / 20.0)) + degree[6]:
					  (lowerLegSwing * (fabs(legSwing) / 10.0)) + degree[6], 1.0, 0.0, 0.0);
			glScalef(0.45, 1.0, 0.45);
			glTranslatef(0.0, -0.65, 0.0);
			glutSolidCube(1.0);
		glPopMatrix();
		
		glPushMatrix();							// Upper right leg
			if(mode == GL_SELECT)
				glLoadName(UPPER_RIGHT_LEG);
			glTranslatef(-0.75, 0.0, 0.0);
			glRotatef(-legSwing + degree[7], 1.0, 0.0, 0.0);
			
			glPushMatrix();
				glScalef(0.45, 1.0, 0.45);
				glTranslatef(0.0, -1.65, 0.0);
				glutSolidCube(1.0);
			glPopMatrix();
			
			if(mode == GL_SELECT)				// Lower right leg
				glLoadName(LOWER_RIGHT_LEG);

			glTranslatef(0.0, -2.0, 0.0);
			glRotatef((legSwing < 5.0)?(lowerLegSwing * (fabs(legSwing) / 10.0)) + degree[8]:
					  (lowerLegSwing * (fabs(legSwing) / 20.0)) + degree[8], 1.0, 0.0, 0.0);
			glScalef(0.45, 1.0, 0.45);
			glTranslatef(0.0, -0.65, 0.0);
			glutSolidCube(1.0);
		glPopMatrix();	
	glPopMatrix();
	
	if (mode == GL_RENDER)
		glutSwapBuffers();
}

/*
 *	Animates the robot
 *	speedScale:		How fast the forward movement is.
 *					Values between 0.5 - 2.5 give best results, with default walking at 1.0.
 */
GLvoid moveRobot(GLfloat speedScale)
{	
	if (animation)
	{
		if (armSwing < lowerArmSwing || armSwing > -(lowerArmSwing))
		{
			armSpeed = -(armSpeed) ;		
		}
		
		armSwing += (armSpeed * speedScale);

		if (legSwing > lowerLegSwingMax || legSwing < -(lowerLegSwingMax))
		{
			legSpeed = -(legSpeed);		
		}
		if (speedScale < 1.0)
		{
			legSwing += (legSpeed * speedScale);		
		}
		else
		{
			legSwing += (legSpeed * speedScale * speedScale);
		}
		
		forward += (0.1 * speedScale * speedScale);
	}

	glTranslatef(0.0, 0.0, (forward));	
}

int main(int argc, char** argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize(WINDOW_WIDTH, WINDOW_HEIGHT); 
    glutInitWindowPosition (100, 100);
    glutCreateWindow ("ROBOT!");
	
	Init();
	
    glutDisplayFunc(Display); 
    glutReshapeFunc(Reshape);
	glutMouseFunc(selectObjects);
	glutMotionFunc(motion);
	
	glutTimerFunc(250, TimerFunc, 1);
    
    glutMainLoop();
    
    return 0;
}
